*****************************************************************
* TRANS123.PRG exports chosen fields of a database file to a    *
*              LOTUS 1-2-3 spreadsheet file                     *
*****************************************************************
* This portion of the program prompts the user for filename,    *
* checks to see that the file exists, and opens the file.       *
*****************************************************************

****************
*  SECTION 1   *
****************
STORE "STOP" TO OK
STORE "Y"    TO ANS
STORE " "    TO DRIVE
STORE " "    TO FNAME
STORE " "    TO FIELDLIST
STORE " "    TO VAR
STORE 0      TO KOUNT
STORE " "    TO DIRECTORY

****************
*  SECTION 2   *
****************

CLEAR
@5,5 SAY "INDICATE THE DISK DRIVE WHICH HOLDS YOUR DATABASE"
@6,5 SAY "FILES --- TYPE A, B, C, ETC."
@8,5
ACCEPT "TYPE THE DRIVE LETTER: " TO DRIVE
STORE UPPER(DRIVE) + ":" TO DRIVE

SET DEFAULT TO &DRIVE

***************
*  SECTION 2A *
***************

CLEAR
@5,5 SAY "INDICATE THE DIRECTORY NAME THE FILE IS LOCATED IN"
@6,5 SAY "  EX. \DBASE                                      "
@ 8,5
ACCEPT "TYPE THE DIRECTORY NAME: " TO DIRECTORY

STORE DRIVE + DIRECTORY TO DRIVE

***************
*  SECTION 3  *
***************

CLEAR
@20,5 SAY "THE FOLLOWING DATABASE FILES ARE ON THE DISK"
@21,5

DO WHILE ANS ="Y"

    RUN DIR &DRIVE*.DBF/P

?
    ACCEPT 'Enter name of the database file, WITHOUT the extension:';
    TO FNAME

    IF   FNAME = "EXIT" 
         clear
         return
    ENDIF
    IF   FNAME = "exit"
         clear
         return
    ENDIF

    IF   LEN(FNAME)>8
         @20,5 SAY "--------------------------------------"
         @21,5 SAY "Filenames MUST be 8 characters or less"
         @22,5 SAY "Do NOT include the DBF extension!"
         @23,5 SAY "--------------------------------------"
         WAIT
         LOOP
    ENDIF

    STORE DIRECTORY + FNAME + ".DBF" TO FNAME

    CLEAR
    IF .NOT. FILE('&FNAME')
        @10,5 SAY "---------------------------------"
        @11,5 SAY "No file located by the name typed"
        @12,5 SAY "Type the filename carefully ---"
        @13,5 SAY "---------------------------------"
        WAIT
        LOOP
    ENDIF

    STORE "N" TO ANS

ENDDO

CLOSE DATABASES

***************
*  SECTION 4  *
***************

USE &FNAME

***************************************************************
* This portion of the program displays the fields in the      *
* database then requests the appropriate field from the user  *
* and stores the field names as FIELD1, FILED2, FILED3, ect.  *
***************************************************************

SET SAFETY OFF
SET EXACT ON

COPY STRUCTURE EXTENDED TO TEMP
SELECT 2

USE TEMP

CLEAR
?
? "Press a key to see the names of ALL FIELDS in your database."
?
? "Prepare a list of each FIELDNAME you want in the worksheet."
?
?

wait

CLEAR
DISPLAY ALL FIELD_NAME OFF
?
WAIT
STORE 1 TO VARNUMB
DO WHILE .T.
IF VARNUMB>16
CLEAR
@5,5 SAY "You've reached maximum no. of 16 fields."
?
wait
exit
endif

STORE "FIELD" + LTRIM(STR(VARNUMB)) TO VAR

?
ACCEPT "Enter field name, or press RETURN alone to stop:";
        TO &VAR

IF LEN(TRIM(&VAR))<1
EXIT
ENDIF

LOCATE FOR FIELD_NAME = UPPER(&VAR)

IF EOF()
?
? CHR(7)
WAIT "-INVALID FIELD NAME! Press a key to try again."
loop
endif

STORE VARNUMB + 1 TO VARNUMB
ENDDO

*************
* SECTION 5 *
*************

****************************************************
* This portion builds a macro string, based on the *
* number of fields selected.                       *
****************************************************

DO WHILE VARNUMB > 0
STORE "FIELD" + LTRIM(STR(VARNUMB)) TO VAR
STORE &VAR + "," + FIELDLIST TO FIELDLIST
STORE VARNUMB-1 TO VARNUMB
ENDDO

STORE SUBSTR(FIELDLIST,1,(LEN(FIELDLIST)-3)) TO FIELDLIST

***************************************************************
* This portion uses the macro string to write the LOTUS file. *
***************************************************************

CLEAR
STORE "C" TO DRIVE

@5,5 SAY "Creating LOTUS worksheet called REPORT.WK1..."
@6,5 SAY "... in the \123 directory.            "
?

SELECT 1
GO TOP
COPY FIELDS &FIELDLIST TO &DRIVE:REPORT.WKS TYPE WKS
RUN COPY &DRIVE:REPORT.WKS &DRIVE:\123\SAMPLE.WK1

CLEAR
CLOSE DATABASES
ERASE TEMP.DBF
RUN ERASE &DRIVE:REPORT.WKS

set default to c

*************
* SECTION 6 *
*************

?         "*******************************************"
?         "* A LOTUS FILE HAS BEEN CREATED USING THE *"
?         "*      SPREADSHEET NAME 'REPORT.WKS       *"
?         "*                                         *"
?         "*  THE 'REPORT.WKS' SPREADSHEET WAS THEN  *"
?         "*  COPIED TO A SECOND  SPREADSHEET NAMED  *"
?         "*  'SAMPLE.WK1' WHICH WAS PLACED IN THE   *"
?         "*  LOTUS DIRECTORY AND 'REPORT.WKS WAS    *"
?         "*              WAS ERASED                 *"
?         "*-----------------------------------------*"
?         "*   THE 'SAMPLE.WK1' SPREADSHEET MAY BE   *"
?         "*       ACCESSED DIRECTLY WITH 1-2-3      *"
?         "*******************************************"
?
?
?         "              Export completed "
?
?         "      *** END OF TRANS123 PROGRAM ***"
?
?
?         "     *** THANK YOU FOR YOUR SUPPORT ***"
WAIT

CLEAR
RETURN

************************
* END OF LOTUS PROGRAM *
************************

